#ifndef _MOPCAPI_H__
#define _MOPCAPI_H__

#include "mess.h"
#include "bug.h"

/* mopcapi.c */
int login(char *email1, char *name, char *nick, char *email2, int expLevel, char *pass);

char **getMachines(int *count, int **id);
int setMachine(char *name);
void addMachine(char *name);


void sendReport(TpkgDescribe *pk,TpkgDescribe *env,int envCount,
		                Tgrade *grades,int grCount);

Tgrade* receiveReport(TpkgDescribe *pk, int *grCount);
int getMaxFeatureID(void);
char *getFeature(int ID);
void addFeature(char *name);
void addFeatureToPackage(char *pkg, int feature);
int* getPackageFeatures(char *pkg);
int getFeatureID(char *name);
char **getPackagesForStatistic(char *pkg,int *count);
void getStatistic(TpkgDescribe *pk,TpkgDescribe *env,int envCount);
char **getPackagesFromDist(int *count, int id );
char **getDists(int *count, int**id);
char **getCathegory(int *count, int **id);
void sendBugReport(Tbug *bug);
#endif
