#include "dmlwrapper.h"
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include "cfile.h"
#include "temp.h"

char dmlLogin[]=""\
"<meta title=\"MOP rejestracja uzytkownika\">"\
"<br>"\
"Nie jestes zarejestrwanym uzytkowniekem MOP'a. Aby zwiekszyc wiarygodnosc<br>"\
"ankiet PLD nie przyjmuje ocen anonimowych.<br>"\
"Aby moc oceniac pakiety podaj swoje dane<br>"\
"Imie i nazwisko    <input id=name><br>"\
"Nick     <input id=nick><br>"\
"e-mail   <input id=email><br>"\
"haslo    <input id=password pass=1>"\
"<br>"\
"<button>"\
"<br>";

void dmlGetLoginInfo(char *name, char *nick, char *email,
		char *password)
{
	struct phash *val;
	val = runDml(dmlLogin);
	strcpy(name, pkt_get_string(val,"name" ,""));
	strcpy(nick, pkt_get_string(val,"nick", ""));
	strcpy(email, pkt_get_string(val,"email",""));
	strcpy(password, pkt_get_string(val,"password",""));

}

char * dmlNewMachine()
{
	struct phash *val;
	val = runDml("<meta title=\"Nowa maszyna\">"\
"<br>"\
"Teraz podaj nazwe dla nowej maszyny. Nie moga insteniec dwie maszyn<br>"\
"o takiej samej nazwie nalezace do jednego urzytkownika<br><br>"\
"Nazwa <input id=name><br>"\
"<button>"\
"<br>");
	return strdup(pkt_get_string(val,"name","default"));
}


char txt_dmlMainMenu[]=""\
"<meta title=\"MOP menu glowne\">"\
"<br>"\
"Wybierz co chcesz zrobic"\
"<menu id=acction res=1>"\
"<item id=5> ocen pakiet z wybranej dystrybucji"\
"<item id=0> ocen dowolny pakiet"\
"<item id=1> dodaj wlasnosc"\
"<item id=2> przypisz wlasnosc dopakietu"\
"<item id=3> pokaz dostepne wlansoci"\
"<item id=4> przegladaj statystyki"\
"<item id=100> KONIEC"\
"</menu><br>";

int dmlMainMenu()
{
	struct phash *val;
	val = runDml(txt_dmlMainMenu);
	return pkt_get_int(val,"acction",0);
}


char txt_dmlGradePackage1[] = ""\
"<meta title=\"MOP -- oecnienianie pakietu\">"
"<br>"\
"Pakiet jest oceniany w jednj lub kilku kategori.<br>"\
"Ponizej jest lista kategorii. Przy kazdej z nich jest przycisk<br>"\
"ktorym mozesz zmienic swoja ocene pakietu w tej katgorii<br><br>";

char txt_dmlGradePackage2[]="<br><button id=send text=ok>  "\
	"<button id=cancel text=cancel>";

char *dmlGradePackage_oneLine(char *name, int mark,int id)
{
	static char buf[500];
	char markTxt[12][30];
	strcpy(markTxt[-1+1],"nie wiem");
	strcpy(markTxt[0+1],"nie dziala");
	strcpy(markTxt[3+1],"raczej nie dziala");
	strcpy(markTxt[7+1],"raczej dziala");
	strcpy(markTxt[10+1],"dziala");
	sprintf(buf,"%45s : %-17s <button id=%d text=zmien><br>",name,
			markTxt[mark+1],id);
	return buf;
}

void dmlGetMark(char *pkg, char *evr, char *cat, int *mark);

int dmlGradePackage(char *pkg, char *evr, char **cat, int *marks, int count)
{
	struct phash *val;
	char txt[10000];
	int i;
	char buf[10];
	char last=0;

printf("W GRADE DML\n");

	do{
		sprintf(txt,"<meta active=%d>",last);
		strcat(txt,txt_dmlGradePackage1);
		for(i=0;i<count;i++)
			strcat(txt,dmlGradePackage_oneLine(cat[i],marks[i],i));
		strcat(txt, txt_dmlGradePackage2);
		val=runDml(txt);

		if(strcmp(pkt_get_string(val,"send",""), "yes") ==0)
			return 1;
		if(strcmp(pkt_get_string(val,"cancel",""), "yes")==0)
			return 0;
		for(i=0;i<count;i++){
			sprintf(buf,"%d",i);
			if(strcmp(pkt_get_string(val,buf,""), "yes")==0){
				dmlGetMark(pkg,evr,cat[i],&(marks[i]));
				last = i;
			}
		}
	}while(1);
	return -1; /* never happen */
}

void dmlGetMark(char *pkg, char *evr, char *cat, int *mark)
{
	struct phash *val;
	char buf[10000];
	sprintf(buf,"<meta title=\"MOP -- ocenianie\"><br>Pakiet:%s<br>"\
			"wersja: %s <br>Twoja ocena w kategori: %s:<br>"\
			"<menu id=mark res=1>"\
			"<item id=-1>nie wiem<item id=0>nie dziala"\
			"<item id=3>raczej nie dziala<item id=7>raczej dziala"\
			"<item id=10>dziala</menu><br>",pkg,evr,cat);
	val = runDml(buf);
	*mark=pkt_get_int(val,"mark",-1);
}

char * dmlSelectPackage(char *comment, char ** pkgs, int count)
{
	char buf[100000], tmp[1000];
	int i;
	struct phash *val;
	sprintf(buf,"<meta title=\"wybierz pakiet\">"\
		"<br>%s<br><menu height=15 width=50 id=package res=1>",comment);
	for(i=0; i<count; i++){
		sprintf(tmp,"<item id=%d>%s",i,pkgs[i]);
		strcat(buf,tmp);
	}
	strcat(buf,"</menu><br>wybierz jeden z pakietow lub "\
			"<button id=cancel text=anuluj>");
	val = runDml(buf);
	if( strcmp( pkt_get_string(val,"cancel", ""), "yes") ==0)
		return NULL;
	return pkgs[pkt_get_int(val,"package",0)];
}

int dmlSelectDist(char **name,int *id, int count)
{
	char buf[10000],tmp[1000];
	struct phash *val;
	int i;
	sprintf(buf,"<meta title=\"wybierz dystrybucje\">"\
			"<br><menu width=50 id=dist res=1>");
	for(i=0; i<count; i++){
		sprintf(tmp,"<item id=%d>%s",id[i],name[i]);
		strcat(buf, tmp);
	}
	strcat(buf,"</menu>");
	val = runDml(buf);
	return pkt_get_int(val,"dist",0);
}


int dmlSelectMachine(char **name, int count)
{
	char buf[10000],tmp[1000];
	struct phash *val;
	int i;
	sprintf(buf,"<meta title=\"wybierz komputer\">"\
			"<br><menu width=50 id=dist res=1>");
	for(i=0; i<count; i++){
		sprintf(tmp,"<item id=%d>%s",i,name[i]);
		strcat(buf, tmp);
	}
	strcat(buf,"</menu><br><button id=new text=nowy>");
	val = runDml(buf);
	if( strcmp( pkt_get_string(val,"new", ""), "yes") ==0)
		return -1;
	return pkt_get_int(val,"dist",0);
}


int dmlAskForBugReport()
{
	struct phash *val;

	val=runDml("<meta title=\"Czy chcesz wyslac raport o bledzie ?\">Oceniles pakiet neagtywnie. Naogol jednak sama tak ocena<br>nie niesie wystarczajaco duzo informacji o bledzie.<br> Mozesz teraz wyslac \"bug report\" zawierajacy opis problemu.<br>Chcesz to zrobic ?<br><button id=\"yes\" text=tak> <button id=\"no\" text=nie>");
	if( strcmp( pkt_get_string(val,"yes", ""), "yes") ==0)
		return 1;
	return 0;
}
	
int dmlEditBugReport(char *pkg, char **cathegory, int *id, int count,
		char *title, int *cid, char **text)
{
	struct phash *val;
	char dml[10000],tmp[100];
	char *fname;
	FILE *f;
	int i;
	struct stat s;
	int first=1;

	do{
		if(!first)
			runDml("Tytol musi miec przynajmniej 3 znaki<br>"
					"Podaj jeszcze raz tytol i kategorie"
					"<br><button>");
		first=0;
		strcpy(dml,"<meta title=\"Educja bugreortu\">" "tytol 
				(powinien dawac ogolne pojecia o bledzie):<br>"
				"<input id=title><br><br>"
				"Kategoria do ktorej mozna zaliczyc blad:");
		strcat(dml,"<menu id=cid>");
		for(i=0; i<count; i++){
			sprintf(tmp,"<item id=%d>%s",id[i],cathegory[i]);
			strcat(dml,tmp);
		}
		strcat(dml,"</menu><br><button id=edit text=\"edytuj tresc\">");
		val=runDml(dml);
		strcpy(title,pkt_get_string(val,"title",""));
		*cid=pkt_get_int(val,"cid",1);

	}while( strlen(title) < 4 );
	
	fname=getTempFileName(getTmp(),"wuch.bugreport");
	f=fopen(fname,"wt");
	if(f==NULL){
		printf("\nCant open file for bugreport editing\n");
		exit(1);
	}
	fprintf(f,"Zamiast tego tekstu podaj mozliwie szczegolowy opis problemu\n");
	fprintf(f,"Nie muszisz podawac informacji o zainstalowanych w systemie pakietahc\nZostanie ona dolaczona automatycznie.\nGdy skonczysz wyjdz z edytora zachowujac zmiany.");
	fclose(f);
	sprintf(tmp,"%s %s",getEditor(), fname);
	system(tmp);
	stat(fname,&s);
	*text=malloc(s.st_size+10);
	f=fopen(fname,"rt");
	i = 0;
	while(!feof(f)){
		(*text)[i++]=fgetc(f);
	}
	(*text)[i-1]='\0';
	fclose(f);	

	val=runDml("<meta title=\"Wyslac bugreport ?\">"
			"wyslac ten bugreport ?"
			"<button id=tak text=tak> <button id=nie text=nie>");
	return( strcmp(pkt_get_string(val,"tak",""),"yes") ==0 );
}	

char * dmlGetPassword(char *email)
{
	struct phash *val;
	char buf[1000];
	sprintf(buf,"<meata title=\"Logowanie\""
			"Podaj haslo dla urzytkownika %s:<br>"
			"<input id=pass><button id=ok>",email);
	val = runDml(buf);
	return(strdup(pkt_get_string(val,"pass" ,"")));
}

int dmlGetLogin(char *email, char *pass)
{
	struct phash *val;
	val=runDml("<meta title=\"Logowanie\""
			"Podaj<br>adres email: <input id=email><br>"
			"haslo: <input id=pass><br><button id=ok>"
			"<br>lub <button id=new text=\"zaloz nowe konto\">");
	if(strcmp(pkt_get_string(val,"ok",""),"yes")==0){
		strcpy(email, pkt_get_string(val,"email",""));
		strcpy(pass, pkt_get_string(val,"pass",""));
		return 1;
	}else{
		return 0;
	}
}

void dmlMsgBox(char *msg)
{
	char buf[1000];
	sprintf(buf,"%s<br><button>",msg);
	runDml(buf);
}
